/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is HJ van Rantwijk.
   - Portions created by HJ van Rantwijk are Copyright (C) 2001-2005
   - HJ van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Michael Vincent van Rantwijk <mv_van_rantwijk@yahoo.com>
   -
*/

/* 
  modified function from navigator.js with one exception
  function getReferrer(doc) because that belong to contentAreaUtils.js.
  this was added for Phoenix support: addPrefListener(observer)
*/

////////////////////////////////////////////////////////////////////////// 
function OpenBookmarkURL(node, datasource, event)
{
  if (node.nodeName == "menu")
    return;
  if (event && (node.id == "bookmarks_groupmark" || node.id == "PT_bookmarks_groupmark" || node.id == "bookmarks_button_groupmark"))
    return;

  var prefValue = mzPreferences.readMyPref("multizilla.bookmark.groups", "int", 0);
  // XXX: new code for bug 3319
  if (prefValue & 1 && node.parentNode.parentNode.getAttribute("group") && !node.hasAttribute("id"))
    node = node.parentNode.parentNode;
  if (!node.hasChildNodes() && node.getAttribute("group") && node.hasAttribute("id")) {
    var numberOfTabs = gBrowser.mTabContainer.childNodes.length-1;
    var newTabs = mzPreferences.readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
    var closeRemaining = mzPreferences.readMyPref("multizilla.bookmark.close-remaining", "bool", false);
    // open dialog for settings
    if (newTabs == 2) {
      window.openDialog("chrome://multiviews/content/multiviewsAskSettings.xul", "", "chrome,modal,centerscreen", getBrowser(), closeRemaining);
      newTabs = gBrowser.mNewTabs;
      closeRemaining = gBrowser.mRemoveRemaining;
      if (gBrowser.mNewTabs == -1)
        return;
    }
    else {
      newTabs = (newTabs == 1);
    }
    var startTab = newTabs ? (numberOfTabs+1) : 0;
    /***
      * Ask for confirmation to prevent mass opening of (unwanted) tabs/urls
      * See also: http://bugzilla.mozdev.org/show_bug.cgi?id=9746
      */
    if (!mzConfirmOpeningOfBookmarks(MZ_OPEN_BOOKMARKS_AS_TABS))
      return;

    OpenBookmarkFolder(node, datasource, (numberOfTabs+1), newTabs, false, false);
    gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[startTab];

    if (closeRemaining) {
      if (newTabs) {
        /* startTab = gBrowser.mTabList[startTab].ordinal-1;
        for (i = startTab; i >= 0; i--)
          gBrowser.removeTab(gBrowser.mTabList[i]); */
      }
      else {
        // for (var i = tabCount; i >= tabIndex; i--)
        for (var i = numberOftabs; i >= tabIndex; i--)
          gBrowser.removeTab(gBrowser.mTabList[i]);
      }
    }
    return;
  }
  var allowMiddleClicks = mzPreferences.readMyPref("multizilla.bookmark.menuitem.allow-middleclick", "bool", false);

  if (node.getAttribute("container") == "true" || (node.nodeName == "menuitem" && event && event.button == 1 && !allowMiddleClicks) )
    return;

  var url = node.getAttribute("id");

  if (!url)
    return;

  try {
    if (datasource) {
      var src = RDF.GetResource(url);
      var prop = RDF.GetResource("http://home.netscape.com/NC-rdf#URL");
      var target = datasource.GetTarget(src, prop, true);
      if (target) {
        target = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
        if (target)
          url = target;
      }
    }
  } catch (ex) {
    return;
  }
  if (url.substring(0, 3) == "NC:")
    return;
  if (window.content) {
    var shiftKey = false;
    var ctrlKey = false;
    var button = false;
    var backupNode = node; // Keep node for future reference!

    if (event) {
      shiftKey = event.shiftKey;
      ctrlKey = event.ctrlKey;
      button = event.button;
    }
    // Is this URL already loaded in one of the tabs?
    if (preventDupeTab(url)) {
      // Do we need to close menupopups?
      if (allowMiddleClicks && mzPreferences.readMyPref("multizilla.bookmark.menuitem.middleclick-closepopups", "bool", true)) 
        mzCloseBookmarkMenu(backupNode);
      return;
    }
    while (node.nodeName != "toolbarbutton" && node.nodeName != "menubar")
      node = node.parentNode;

    if ((node.nodeName == "menubar" && pref && pref.getBoolPref("multizilla.newtabfor.bookmarks") && !shiftKey) ||
        (node.nodeName == "toolbarbutton" /* XXX: see bug 2675 && node.id != "bookmarks-button" */ && 
        pref && pref.getBoolPref("multizilla.newtabfor.personal-toolbar") && !shiftKey) || 
        ctrlKey || button == 1) {
      if (url.substring(0,10) == "javascript") {
	    if (url.indexOf("getSelection(") != -1)
          loadURI(url, null);
        else
          setTimeout(function() { loadURI(url, null) }, 0, gBrowser.selectedTab = getBrowser().addTab());
      }
      else {
        if (ctrlKey && shiftKey) { // Do we need to open a new window?
          window.open(url);
          return;
        }
        var tab = null;
        var browser = checkForBlankTab();

        if (browser) {
          browser.loadURI(getShortcutOrURI(url, null));
          tab = gBrowser.getTabForBrowser(browser);
        }
        else
          tab = gBrowser.addTab(getShortcutOrURI(url));

        var loadInBackground = mzPreferences.readMyPref("multizilla.bookmark.loadInBackground", "bool", false);
        // Select the new tab, based on the pref setting and shiftKey!
        if (!loadInBackground && !shiftKey || loadInBackground && shiftKey)
          gBrowser.selectedTab = tab;
      }
    }
    else {
      loadURI(url, null);
      window.content.focus();
    }
    // Do we need to close menupopups?
    if (allowMiddleClicks && mzPreferences.readMyPref("multizilla.bookmark.menuitem.middleclick-closepopups", "bool", true)) 
      mzCloseBookmarkMenu(backupNode);
  }
  else {
    openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", url);
  }
}
//////////////////////////////////////////////////////////////////////////
function mzCloseBookmarkMenu(aNode)
{
  while (aNode.nodeName != "toolbarbutton" && aNode.nodeName != "menubar") {
    aNode = aNode.parentNode;
    if (aNode.nodeName == "menupopup")
      aNode.hidePopup();
  }
  // We need to 'Close" the Bookmarks button on the menubar
  if (aNode.nodeName == "menubar") {
    var menu = document.getElementById("BookmarksMenu");
    menu.setAttribute("_moz-menuactive", false);
  }
}
//////////////////////////////////////////////////////////////////////////
function BrowserLoadURL(aTriggeringEvent)
{
  var url = gURLBar.value;

  if (url.match(/^view-source:/)) {
    BrowserViewSourceOfURL(url.replace(/^view-source:/, ""), null, null);
  } else {
    // Check the pressed modifiers: (also see bug 97123)
    // Modifier Mac | Modifier PC | Action
    // -------------+-------------+-----------
    // Command      | Control     | New Window/Tab
    // Shift+Cmd    | Shift+Ctrl  | New Window/Tab behind current one
    // Option       | Shift       | Save URL (show Filepicker)

    // If false, the save modifier is Alt, which is Option on Mac.
    var modifierIsShift = true;

    try {
      modifierIsShift = pref.getBoolPref("ui.key.saveLink.shift");
    }
    catch (ex) {}

    var shiftPressed = false;
    var saveModifier = false; // if the save modifier was pressed

    if (aTriggeringEvent && 'shiftKey' in aTriggeringEvent && 'altKey' in aTriggeringEvent) {
      saveModifier = modifierIsShift ? aTriggeringEvent.shiftKey : aTriggeringEvent.altKey;
      shiftPressed = aTriggeringEvent.shiftKey;
    }
    var tabBrowser = getBrowser();
    url = getShortcutOrURI(url);
    var newTab = mzPreferences.readMyPref("multizilla.newtabfor.locationbar", "bool", false);
    // Accept both Control and Meta (=Command) as New-Window-Modifiers
    if ((aTriggeringEvent &&
        (('ctrlKey' in aTriggeringEvent && aTriggeringEvent.ctrlKey) ||
         ('metaKey' in aTriggeringEvent && aTriggeringEvent.metaKey) || 
         ('button' in aTriggeringEvent && aTriggeringEvent.button == 1))) || newTab) {
      // Check if user requests Tabs instead of windows
      var openTab = false;

      try {
        openTab = pref.getBoolPref("browser.tabs.opentabfor.urlbar");
      }
      catch (ex) {}

      if (openTab || newTab) {
        var tab = preventDupeTab(url, false)

        if (tab == null) {
          var browser = checkForBlankTab(tabBrowser);
          // Do we have a blank/unused tab available?        
          if (browser) {
            tab = tabBrowser.getTabForBrowser(browser);
            browser.loadURI(url);
          }
          else // Open link in a new tab when there's no blank tab available
            tab = tabBrowser.addTab(url);
        }
        // Focus new tab unless shift is pressed
        if (!shiftPressed) {
          tabBrowser.userTypedValue = null;
          tabBrowser.selectedTab = tab;
        }
      } 
      else {
        // Open a new window with the URL
        var newWin = openDialog(getBrowserURL(), "_blank", "all,dialog=no", url);
        // Reset url in the urlbar, copied from handleURLBarRevert()
        var oldURL = tabBrowser.currentURI.spec;

        if (oldURL != "about:blank") {
          gURLBar.value = oldURL;
          SetPageProxyState("valid", null);
        } else
          gURLBar.value = "";

        tabBrowser.userTypedValue = null;
        // Focus old window if shift was pressed, as there's no
        // way to open a new window in the background
        // XXX this doesn't seem to work
        if (shiftPressed) {
          //newWin.blur();
          content.focus();
        }
      }
    }
    else if (saveModifier) {
      try {
        // Firstly, fixup the url so that (e.g.) "www.foo.com" works
        const nsIURIFixup = Components.interfaces.nsIURIFixup;

        if (!gURIFixup)
          gURIFixup = Components.classes["@mozilla.org/docshell/urifixup;1"].getService(nsIURIFixup);

        url = gURIFixup.createFixupURI(url, nsIURIFixup.FIXUP_FLAGS_MAKE_ALTERNATE_URI).spec;
        // Open filepicker to save the url
        saveURL(url, "");
      }
      catch(ex) {
        // XXX Do nothing for now.
        // Do we want to put up an alert in the future?  Mmm, l10n...
      }
    } else {
      // No modifier was pressed, load the URL normally and
      // focus the content area
      loadURI(url);
      content.focus();
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function LoadBookmarksCallback() // for mozilla v1.4+
{
  // BookmarksUtils.isValidTargetContainer = mzIsValidTargetContainer;
  initServices();
  initBMService();
  BMSVC.readBookmarks();
  var bt = document.getElementById("bookmarks-ptf");

  if (bt)
    bt.database.AddObserver(BookmarksToolbarRDFObserver);
  window.addEventListener("resize", BookmarksToolbar.resizeFunc, false);
  controllers.appendController(BookmarksMenuController);

  var personalToolbar = document.getElementById("bookmarks-ptf"); // (fix for bug 4327)
  personalToolbar.builder.rebuild();

  mzFeedHandler.init();
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroup(element, datasource, id)
{
  if (!datasource)
    return;
  if (element)
    id = element.getAttribute("id");
  else {
    id = mzPreferences.readMyPref("multizilla.tabs.groupmark", "string", null);
    if (!id)
      return;
  }
  var resource = RDF.GetResource(id, true);
  OpenBookmarkGroupFromResource(resource, datasource);
}
//////////////////////////////////////////////////////////////////////////
// This is added to maintain backward compatibility. We should remove it 
// when people start using a more recent mozilla build.
//////////////////////////////////////////////////////////////////////////
function updateGroupmarkMenuitem(id)
{
  const disabled = (gBrowser.mPanelContainer.childNodes.length == 1);
  document.getElementById(id).setAttribute("disabled", disabled);
}
//////////////////////////////////////////////////////////////////////////
function BrowserViewSourceOfURL(url, charset, pageCookie, aEvent)
{
  /***
    * Don't open the source in a tab when we're being called from the Tidy Validation add-on
    * We can eventually validate the calling ID's by checking them against a preference!
    */
  if (aEvent == undefined && mzPreferences.readMyPref("multizilla.newtabfor.view-source", "bool", false)) {
    var tab = null;
    var loadFromURL = true;
    url = 'view-source:' + url.replace(/view-source:/ig, '');
    var browser = checkForBlankTab();
    tab = preventDupeTab(url, false, gBrowser);

    if (tab) {
      gBrowser.selectedTab = tab;
      return;
    }
    try {
      if (typeof(pageCookie) == "object" || typeof(pageCookie) == "function") {
        tab = (browser) ? gBrowser.getTabForBrowser(browser) : gBrowser.addTab(null, null, null, "restoreTab", null, false);
        gBrowser.selectedTab = tab;
        var pageLoader = getBrowser().webNavigation.QueryInterface(Components.interfaces.nsIWebPageDescriptor);
        
        if ('loadPage' in pageLoader) { // For Mozilla builds dated 2004-07-14 15:53 and later
          pageLoader.loadPage(pageCookie, Components.interfaces.nsIWebPageDescriptor.DISPLAY_AS_SOURCE);
        }
        else { // For older Mozilla builds work
          pageLoader.LoadPage(pageCookie, Components.interfaces.nsIWebPageDescriptor.DISPLAY_AS_SOURCE);
        }
        loadFromURL = false;
      }
    } catch(ex) { 
	}
    if (loadFromURL) {
      if (!tab)
        tab = browser ? gBrowser.getTabForBrowser(browser) : gBrowser.addTab(null, null, null, "restoreTab", null, false);
      gBrowser.selectedTab = tab;
      loadURI(url);
    }
  }
  else {
    openDialog("chrome://navigator/content/viewSource.xul", "_blank",
               "scrollbars,resizable,chrome,dialog=no", url, charset, pageCookie);
  }
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroupFromResource(resource, datasource)
{
  var urlProperty = RDF.GetResource("http://home.netscape.com/NC-rdf#URL");
  var rdfContainer = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
  rdfContainer.Init(datasource, resource);
  var containerChildren = rdfContainer.GetElements();
  var index = 0;

  while (containerChildren.hasMoreElements()) {
    resource = containerChildren.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var target = datasource.GetTarget(resource, urlProperty, true);
    if (target) {
      var URL = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      if (URL /* && URL != 'about:blank' */ ) {
        if (!preventDupeTab(URL)) {
          if (index == 0)
            gBrowser.loadURI(URL);
          else 
            gBrowser.addTab(URL);
          index++;    
        }
      }
    }
  }  
  if (index == 0)
    return; // If the bookmark group was completely invalid, just bail.

  /* var numberOfTabs = gBrowser.mPanelContainer.childNodes.length-1;
  var inBackground = pref.getBoolPref("browser.tabs.loadInBackground") ? 0 : numberOfTabs;
  var tabs = gBrowser.mTabContainer.childNodes;
  gBrowser.selectedTab = tabs[inBackground]; */
  var numberOfTabs = gBrowser.mTabContainer.childNodes.length-1;
  var activeTab = mzPreferences.readMyPref("browser.tabs.loadInBackground", "bool", false) ? 0 : numberOfTabs;
  gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[activeTab];
}
//////////////////////////////////////////////////////////////////////////
// This modified version can handle multiple pref observers
//////////////////////////////////////////////////////////////////////////
function mzAddPrefListener(observer)
{
  var domains = ("domains" in observer) ? observer.domains : [observer.domain];
  try {
    var pbi = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    for (var i = 0; i < domains.length; i++)
      pbi.addObserver(domains[i], observer, false);
  } catch(ex) {
    dump("Failed to observe pref: " + ex + "\n");
  }
}
//////////////////////////////////////////////////////////////////////////
// This modified version can handle multiple pref observers
//////////////////////////////////////////////////////////////////////////
function mzRemovePrefListener(observer)
{
  var domains = ("domains" in observer) ? observer.domains : [observer.domain];
  try {
    var pbi = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    for (var i = 0; i < domains.length; i++)
      pbi.removeObserver(domains[i], observer, false);
  } catch(ex) {
    dump("Failed to remove observe for pref: " + ex + "\n");
  }
}
//////////////////////////////////////////////////////////////////////////
// Fill in tooltips for personal toolbar (older versions of navigator.js)
//////////////////////////////////////////////////////////////////////////
function FillInPTTooltip(tipElement) // for mozilla v1.4
{
  var title = tipElement.label;
  var url = tipElement.statusText;

  if (!title && !url)
    return false;

  var tooltipTitle = document.getElementById("ptTitleText");
  var tooltipUrl = document.getElementById("ptUrlText"); 

  if (title && title != url) {
    tooltipTitle.removeAttribute("hidden");
    tooltipTitle.setAttribute("value", title);
  } else  {
    tooltipTitle.setAttribute("hidden", "true");
  }
  if (url) {
    tooltipUrl.removeAttribute("hidden");
    tooltipUrl.setAttribute("value", url);
  } else {
    tooltipUrl.setAttribute("hidden", "true");
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'updateOverflowMenu' in bookmarksMenu.js
//////////////////////////////////////////////////////////////////////////
BookmarksToolbar.updateOverflowMenu = function(aMenuPopup)
{
   var hbox = document.getElementById("bookmarks-ptf");
   // There will be two menu items missing from the overflow menu, without this modification
   // We replace mozilla's template, this is why we have two extra childnodes,
   // childNodes[0] = tooltip and childNodes[1] = our modified template
   for (var i = 2; i < hbox.childNodes.length; i++) {
     var button = hbox.childNodes[i];
     var menu = aMenuPopup.childNodes[(i-2)];
     if (menu.hidden == button.collapsed)
       menu.hidden = !menu.hidden;
   }
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'StatusbarViewPopupManager()' in navigator.js
// This opens the more powerful permission manager of MultiZilla.
//////////////////////////////////////////////////////////////////////////
function StatusbarViewPopupManager()
{
  var hostPort = "";
  var sourceURI = getBrowser().selectedBrowser.currentURI;

  try {
    hostPort = (sourceURI.spec.match(/file:/i)) ? "file:" : sourceURI.hostPort;
  }
  catch(ex) { 
    hostPort = sourceURI.spec;
  }
  mzManagers.openPermissionManager("popupManager", hostPort);
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'gotoHistoryIndex()' in navigator.js
//////////////////////////////////////////////////////////////////////////
function gotoHistoryIndex(aEvent)
{
  var index = aEvent.originalTarget.getAttribute("index");

  if (!index)
    return false;

  if (index == "back")
    gBrowser.goBackGroup();
  else if (index ==  "forward")
    gBrowser.goForwardGroup();
  else {
    var historyEntry;
    var popup = aEvent.originalTarget.parentNode;
    var tabContextMenu = (popup.parentNode.nodeName == "xul:menu") ? true : false; // Called from tab context menu?
    var sourceTab = tabContextMenu ? gBrowser.mContextTab : gBrowser.selectedTab;
    var browser = gBrowser.getBrowserForTab(sourceTab);
    var sessionHistory = browser.sessionHistory;

    if (aEvent.button == 1) { // a middle-click on a history entry will be opened in a new tab!
      /* var popup = aEvent.originalTarget.parentNode;
      var tabContextMenu = (popup.parentNode.nodeName == "xul:menu") ? true : false; // Called from tab context menu?
      var sourceTab = tabContextMenu ? gBrowser.mContextTab : gBrowser.selectedTab;
      var browser = gBrowser.getBrowserForTab(sourceTab);
      var sessionHistory = browser.sessionHistory; */
      var sourceIndex = sessionHistory.index; // Backup index of sourceTab
      var newIndex = aEvent.originalTarget.getAttribute("index"); // Get selected index
      historyEntry = sessionHistory.getEntryAtIndex(newIndex, true); // This also updates the index!
      // Prevent blocked .jar and .xpi files to be loaded from history
      if (mzIsBlockedXPInstall(historyEntry.URI.spec))
        return false;
      // Don't allow blank tabs to be duplicated. What the heck is "about://blank/" ??
      if (historyEntry.URI.spec == "about:blank" || historyEntry.URI.spec == "about://blank/") {
        sessionHistory.getEntryAtIndex(sourceIndex, true); // Restore original index
        return false;
      }
      popup.hidePopup(); // Close the popup/menupopup/xul:menupopup

      if (tabContextMenu) {
        // Set menu item 'Tab History' inactive state and close tab context menu
        aEvent.target.parentNode.setAttribute("_moz-menuactive", false);
        popup = document.getElementById("tabContextMenu");
        popup.hidePopup();
      }
      gBrowser.duplicateTab(sourceTab, false);
      sessionHistory.getEntryAtIndex(sourceIndex, true); // Restore original index
      return true;
    }
    try {
      historyEntry = sessionHistory.getEntryAtIndex(index, true);
      // Previously blocked file should not be loaded from Go and Tab History
      if (mzIsBlockedXPInstall(historyEntry.URI.spec))
        return false;
      getWebNavigation().gotoIndex(index);
    }
    catch(ex) {
      // dump("\nOOPS: " + ex);
      return false;
    }
  }
  return true;
}
var gLineNumber = 0;
var gLastLineNumber = 0;
const nsISelectionPrivate = Components.interfaces.nsISelectionPrivate;
const nsISelectionController = Components.interfaces.nsISelectionController;
//////////////////////////////////////////////////////////////////////////
// Modified copy of 'ViewSourceGoToLine()' in viewsource.js
//////////////////////////////////////////////////////////////////////////
function ViewSourceGoToLine()
{
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                .getService(Components.interfaces.nsIPromptService);
  var viewSourceBundle = srGetStrBundle('chrome://navigator/locale/viewSource.properties');
  var input = {value:gLastLineNumber};

  for (;;) {
    var ok = promptService.prompt(window, viewSourceBundle.GetStringFromName('goToLineTitle'),
                                  viewSourceBundle.GetStringFromName('goToLineText'), input, 
                                  null, {value:0});

    if (!ok) 
      return;

    var line = parseInt(input.value);

    if (!(line > 0)) {
      promptService.alert(window, viewSourceBundle.GetStringFromName('invalidInputTitle'),
                          viewSourceBundle.GetStringFromName('invalidInputText'));
      continue;
    }
    gLineNumber = line;
    var found = mzGoToLine();

    if (found) {
      break;
    }
    promptService.alert(window, viewSourceBundle.GetStringFromName('outOfRangeTitle'),
                        viewSourceBundle.GetStringFromName('outOfRangeText'));
  }
}
//////////////////////////////////////////////////////////////////////////
// Modified copy of 'goToLine()' in viewsource.js
//////////////////////////////////////////////////////////////////////////
function mzGoToLine()
{
  var pre;
  var line = parseInt(gLineNumber);
  var viewsource = window._content.document.body;

  for (var lbound = 0, ubound = viewsource.childNodes.length; ; ) {
    var middle = (lbound + ubound) >> 1;
    pre = viewsource.childNodes[middle];
    var firstLine = parseInt(pre.id.substring(4));
    if (lbound == ubound - 1)
      break;
    if (line >= firstLine)
      lbound = middle;
	else
      ubound = middle;
  }
  var result = {};
  var found = mzFindLocation(pre, line, null, -1, false, result);

  if (!found)
    return false;

  var selection = window._content.getSelection();
  selection.removeAllRanges();
  selection.QueryInterface(nsISelectionPrivate).interlinePosition = true;
  selection.addRange(result.range);

  if (!selection.isCollapsed) {
    selection.collapseToEnd();
    var offset = result.range.startOffset;
    var node = result.range.startContainer;
    if (offset < node.data.length)
      selection.extend(node, offset);
    else {
      node = node.nextSibling ? node.nextSibling : node.parentNode.nextSibling;
      selection.extend(node, 0);
    }
  }
  var selCon = getBrowser().docShell
    .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
    .getInterface(Components.interfaces.nsISelectionDisplay)
    .QueryInterface(nsISelectionController);  
  selCon.setDisplaySelection(nsISelectionController.SELECTION_ON);
  selCon.setCaretEnabled(true);
  selCon.setCaretVisibilityDuringSelection(true);
  selCon.scrollSelectionIntoView(nsISelectionController.SELECTION_NORMAL,
                                 nsISelectionController.SELECTION_FOCUS_REGION, true);

  getBrowser().removeEventListener("load", mzGoToLine, true);
  gLastLineNumber = gLineNumber;
  return true;
}
//////////////////////////////////////////////////////////////////////////
// Modified copy of 'findLocation()' in viewsource.js
//////////////////////////////////////////////////////////////////////////
function mzFindLocation(pre, line, node, offset, interlinePosition, result)
{
  if (node && !pre)
    for (pre = node; pre.nodeName != "PRE"; pre = pre.parentNode);

  var curLine = parseInt(pre.id.substring(4));
  var treewalker = window._content.document.createTreeWalker(pre, NodeFilter.SHOW_TEXT, null, false);
  var firstCol = 1;
  var found = false;

  for (var textNode = treewalker.firstChild(); textNode && !found; textNode = treewalker.nextNode()) {
    var lineArray = textNode.data.split(/\n/);
    var lastLineInNode = curLine + lineArray.length - 1;

    if (node ? (textNode != node) : (lastLineInNode < line)) {
      if (lineArray.length > 1)
        firstCol = 1;
      firstCol += lineArray[lineArray.length - 1].length;
      curLine = lastLineInNode;
      continue;
    }
    for (var i = 0, curPos = 0; i < lineArray.length; curPos += lineArray[i++].length + 1) {
      if (i > 0)
        curLine++;
      if (node) {
        if (offset >= curPos && offset <= curPos + lineArray[i].length) {
          if (i > 0 && offset == curPos && !interlinePosition) {
            result.line = curLine - 1;
            var prevPos = curPos - lineArray[i - 1].length;
            result.col = (i == 1 ? firstCol : 1) + offset - prevPos;
          } 
          else {
            result.line = curLine;
            result.col = (i == 0 ? firstCol : 1) + offset - curPos;
          }
          found = true;
          break;
        }
      } 
      else {
        if (curLine == line && !("range" in result)) {
          result.range = document.createRange();
          result.range.setStart(textNode, curPos);
          result.range.setEndAfter(pre.lastChild);
        } 
        else if (curLine == line + 1) {
          result.range.setEnd(textNode, curPos - 1);
          found = true;
          break;
        }
      }
    }
  }
  return found;
}
////////////////////////////////////////////////////////////////////////////////
function mzSelectErrorInSource()
{
  window._content.focus();
  if (gLineNumber > 0)
    getBrowser().addEventListener("load", mzGoToLine, true);
  // We don't want the location bar focused!
  setTimeout(WindowFocusTimerCallback, 0, content);
}
//////////////////////////////////////////////////////////////////////////
function getBrowserForDocument(aDocument)
{  
  var browsers = gBrowser.mPanelContainer.childNodes.length;

  for (var i = 0; i < browsers; i++) {
    if (gBrowser.getBrowserAtIndex(i).contentDocument == aDocument)
      return gBrowser.getBrowserAtIndex(i);
    else if (content.frames.length > 0) {
      for (var frame_nr = 0; frame_nr < content.frames.length; frame_nr++) {
        if (content.frames[frame_nr].length > 0) { // deep nested frames
          if (isFrameDocumentContainer(content.frames[frame_nr], aDocument))
            return gBrowser.getBrowserAtIndex(i);
        }
        if (content.frames[frame_nr].document == aDocument)
          return gBrowser.getBrowserAtIndex(i);
      }
    }
  }
  return null;
}
//////////////////////////////////////////////////////////////////////////
function isFrameDocumentContainer(aFrame, aDocument)
{
  if (!aFrame || !aDocument)
    return false;

  for (var i = 0; i < aFrame.length; i++) {
    if (aFrame.frames[i].length > 0) {
      if (isFrameDocumentContainer(aFrame[i], aDocument)) // recursive call
        return true;
    }
    if (aFrame.frames[i].document == aDocument)
      return true;
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////
nsBrowserStatusHandler.prototype.onSecurityChange = function(aWebProgress, aRequest, aState) 
{
  const wpl = Components.interfaces.nsIWebProgressListener;
  var secState = "";

  this.securityButton.removeAttribute("label");
  this.urlBar.removeAttribute("domain");

  switch (aState) {
    case wpl.STATE_IS_SECURE | wpl.STATE_SECURE_HIGH:
      secState = "high";
    case wpl.STATE_IS_SECURE | wpl.STATE_SECURE_LOW:
      if (secState == "") 
        secState = "low";
      this.securityButton.setAttribute("level", secState);

      if (this.urlBar)
        this.urlBar.setAttribute("level", secState);
      try {
        var cert = mzGetServerCert();

        if (cert.organization.indexOf("xn-") != -1)
          this.urlBar.setAttribute("domain", "check");

        if (mzPreferences.readMyPref("multizilla.check.domain-names", "bool", true)) {
          var browser = getBrowserForDocument(gBrowser.contentWindow.document);
          var host = browser.docShell.currentURI.host;

          if (browser.lastSSLHost != host) {
            var idnService = Components.classes["@mozilla.org/network/idn-service;1"].getService(Components.interfaces.nsIIDNService);
            var isIDN = idnService.isACE(host);
            var ACEhost = isIDN ? host : idnService.convertUTF8toACE(host);
            var UTF8host = isIDN ? idnService.convertACEtoUTF8(host) : host;

            if (browser.lastSSLHost != ACEhost && browser.lastSSLHost != UTF8host) {
              var UTF8hostFound = !mzIDNHistory(UTF8host, false, false, false);
              var ACEhostFound = !mzIDNHistory(ACEhost, false, false, false);

              if (!isIDN && idnService.isACE(ACEhost))
                isIDN = true;
              if (isIDN)
                host = ACEhost;
              if (!UTF8hostFound && !ACEhostFound) {
                var numberOfKeys = mzIDNHistory(null);
                gDomainChecker.onSSLChecked(browser, [host], true, isIDN, cert, numberOfKeys);
              }
              else {
                if (isIDN && !ACEhostFound && UTF8hostFound)
                  mzDisplaySSLPrompt(browser, [ACEhost, UTF8host], false, isIDN, cert);
                else if (!isIDN && ACEhostFound && !UTF8hostFound)
                  mzDisplaySSLPrompt(browser, [UTF8host, ACEhost], false, isIDN, cert);
              }
            }
            browser.lastSSLHost = host;
          }
        }
        this.securityButton.setAttribute("label", cert.organization);
      } catch(ex) {
        // dump("ex: " + ex);
      }
      break;
    case wpl.STATE_IS_BROKEN:
      this.securityButton.setAttribute("level", "broken");
      this.urlBar.setAttribute("level", "broken");
      break;
    case wpl.STATE_IS_INSECURE:
    default:
      this.securityButton.removeAttribute("level");
      this.urlBar.removeAttribute("level");
      break;
  }
  if (this.mzSecurityIcon == undefined)
    this.mzSecurityIcon = document.getElementById("mzSecurityIcon");

  var securityUI = getBrowser().securityUI;

  if (securityUI){
    if (securityUI.tooltipText) {
      this.securityButton.setAttribute("tooltiptext", securityUI.tooltipText);
      this.mzSecurityIcon.setAttribute("tooltiptext", securityUI.tooltipText);
    }
  }
  else {
    this.securityButton.removeAttribute("tooltiptext");
    this.mzSecurityIcon.removeAttribute("tooltiptext");
  }
}
//////////////////////////////////////////////////////////////////////////
nsBrowserStatusHandler.prototype.startDocumentLoad = function(aRequest) 
{
  const nsIChannel = Components.interfaces.nsIChannel;
  var urlStr = aRequest.QueryInterface(nsIChannel).URI.spec;
  var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

  gBrowser = getBrowser();
  gBrowser.userTypedClear++;
  gBrowser.mCurrentBrowser.feeds = null;

  try {
    observerService.notifyObservers(content, "StartDocumentLoad", urlStr);
  } catch(ex) {
  }
}
//////////////////////////////////////////////////////////////////////////
function mzGetServerCert()
{
  const nsISSLStatusProvider = Components.interfaces.nsISSLStatusProvider;
  const nsISSLStatus = Components.interfaces.nsISSLStatus;

  var sp = null;
  var status = null;
  var ui = gBrowser.securityUI;

  if (ui) {
    sp = ui.QueryInterface(nsISSLStatusProvider);
    if (sp)
      status = sp.SSLStatus;
  }
  if (status)
    status = status.QueryInterface(nsISSLStatus);
  if (status) {
    return status.serverCert;
  }
  return "";
}
//////////////////////////////////////////////////////////////////////////
function BrowserOpenTab()
{
  if (!gInPrintPreviewMode) {
    var uriToLoad;
    try {
      switch ( pref.getIntPref("browser.tabs.loadOnNewTab") )
      {
        case -1:
          var handler = Components.classes['@mozilla.org/commandlinehandler/general-startup;1?type=browser']
                                  .getService(Components.interfaces.nsICmdLineHandler);
          uriToLoad = handler.defaultArgs.split("\n")[0];
          if (!/\S/.test(uriToLoad))
            uriToLoad = "about:blank";
          break;
        case 1:
          uriToLoad = pref.getCharPref("browser.startup.homepage");
          break;
        case 2:
          uriToLoad = getWebNavigation().currentURI.spec;
          break;
        case 3:
          uriToLoad = pref.getCharPref("multizilla.preferred.location");
          break;
        default:
          uriToLoad = "about:blank";
          break;
      }
    } catch(e) {
      uriToLoad = "about:blank";
    }
    gBrowser.selectedTab = gBrowser.addTab(uriToLoad);
    var navBar = document.getElementById("nav-bar");
    if (uriToLoad == "about:blank" && !navBar.hidden && window.locationbar.visible)
      setTimeout("gURLBar.focus();", 0);
    else
      setTimeout("content.focus();", 0);
  }
}
//////////////////////////////////////////////////////////////////////////
function BrowserSearchInternet()
{
  try {
    var searchEngineURI = pref.getCharPref("browser.search.defaultengine");
    var openNewTab = pref.getBoolPref("multizilla.newtabfor.websearch");

    if (searchEngineURI) {          
      var searchRoot = getSearchUrl("searchForm");

      if (searchRoot) {
        if (openNewTab)
          gBrowser.selectedTab = gBrowser.addOrGetTab(searchRoot);
        else
          loadURI(searchRoot);
        return;
      }
      else {
        var searchDS = Components.classes["@mozilla.org/rdf/datasource;1?name=internetsearch"]
                                 .getService(Components.interfaces.nsIInternetSearchService);
        var searchURL = searchDS.GetInternetSearchURL(searchEngineURI, "ABC", 0, 0, {value:0});

        if (searchURL) {
          searchRoot = searchURL.match(/[a-z]+:\/\/[a-z.-]+/);

          if (searchRoot) {
            if (openNewTab)
              gBrowser.selectedTab = gBrowser.addOrGetTab(searchRoot + "/");
            else
              loadURI(searchRoot + "/");
            return;
          }
        }
      }
    }
  } catch (ex) {
  }
  if (openNewTab)
    gBrowser.selectedTab = gBrowser.addOrGetTab(gNavigatorRegionBundle.getString("otherSearchURL"));
  else 
    loadURI(gNavigatorRegionBundle.getString("otherSearchURL"));
}
//////////////////////////////////////////////////////////////////////////
const gPopupBlockerObserver =
{
  _blockedWindowButton: null,
  _nsIPermissionManager: Components.interfaces.nsIPermissionManager,
  _multizillaBundle : srGetStrBundle("chrome://multiviews/locale/multizilla.properties"),
  _popupInfoMessagePrefString : "multizilla.blocked-popup.show-info-message",
  _popupImageURL : "chrome://multiviews/content/images/blocked-window-menu-button.png",
  _showCloseButtonPrefString : "multizilla.info-messages.show-close-botton",

  findChildShell: function(aDocShell, aSoughtURI)
  {
    var webNav = aDocShell.QueryInterface(Components.interfaces.nsIWebNavigation);

    if (webNav.currentURI.spec == aSoughtURI.spec)
      return aDocShell;
      
    var node = aDocShell.QueryInterface(Components.interfaces.nsIDocShellTreeNode);

    for (var i = 0; i < node.childCount; ++i) {
      var docShell = node.getChildAt(i);

      docShell = this.findChildShell(docShell, aSoughtURI);

      if (docShell == aSoughtURI)
        return docShell;
    }
    return null;
  },

  onUpdatePageReport: function(aBrowser)
  {
    if (!this._blockedWindowButton)
      this._blockedWindowButton = document.getElementById("blocked-windows-button");

    // if (gBrowser.mCurrentBrowser.mBlockedWindows)
    if (aBrowser.mBlockedWindows)
    {
      if (aBrowser == gBrowser.mCurrentBrowser)
        this._blockedWindowButton.setAttribute("blocked", "true");

      if (mzPreferences.readMyPref(this._popupInfoMessagePrefString, "bool", true))
      {
        var messageText, tooltipText;
        // var blockedPopups = gBrowser.selectedBrowser.mNumberOfBlockedWindows;
        var blockedPopups = aBrowser.mNumberOfBlockedWindows;
        // var currentURI = gBrowser.selectedBrowser.webNavigation.currentURI;
        var currentURI = aBrowser.webNavigation.currentURI;
        var host = (currentURI.scheme == "file") ? "file:" : currentURI.hostPort;

        if (blockedPopups == 1) {
          messageText = this._multizillaBundle.formatStringFromName("popupWarning", [host], 1);
          tooltipText = this._multizillaBundle.GetStringFromName("blockedPopupTooltip");
          this._blockedWindowButton.setAttribute("tooltiptext", tooltipText);
        }
        else {
          messageText = this._multizillaBundle.formatStringFromName("popupWarningMultiple", [host, blockedPopups], 2);
          tooltipText = this._multizillaBundle.formatStringFromName("blockedPopupsTooltip", [blockedPopups], 1);
          this._blockedWindowButton.setAttribute("tooltiptext", tooltipText);
        }
        var topBottom = gBrowser.mTopTabs ? "top" : "bottom";
        var showCloseButton = mzPreferences.readMyPref(this._showCloseButtonPrefString, "bool", true);
        gBrowser.showInfoMessage(aBrowser, this._popupImageURL, messageText, "blockedWindowsPopupmenu", topBottom, showCloseButton, false, null);
      }
    }
    else
      this._blockedWindowButton.removeAttribute("blocked");
  },

  setPopupsPermission: function(aEvent)
  {
    var currentURI = gBrowser.selectedBrowser.webNavigation.currentURI;
    currentURI.spec = (currentURI.scheme == "file") ? "file:" : currentURI.scheme + "://" + currentURI.hostPort.replace(/^www./, '');
    var shouldBlock = (aEvent.target.getAttribute("block") == "true");
    var permission = shouldBlock ? this._nsIPermissionManager.DENY_ACTION : this._nsIPermissionManager.ALLOW_ACTION;
    var pm = Components.classes["@mozilla.org/permissionmanager;1"].getService(this._nsIPermissionManager);
    pm.add(currentURI, "popup", permission);
    gBrowser.hideInfoMessage(gBrowser.selectedBrowser);
  },
  
  fillPopupList: function(aEvent)
  {
    var currentURI = gBrowser.selectedBrowser.webNavigation.currentURI;
    var host; // = (currentURI.scheme == "file") ? "file:" : currentURI.hostPort;

    try {
      host = (currentURI.scheme == "file") ? "file:" : currentURI.hostPort;
    } catch(ex) {
      // No hostPort
      var url = currentURI.spec;
      if (url.match(/^javascript:/i))
        host = "javascript:";
    }
    var blockedPopupAllowSite = document.getElementById("blockedPopupAllowSite");

    try {
      blockedPopupAllowSite.removeAttribute("hidden");
      var pm = Components.classes["@mozilla.org/permissionmanager;1"].getService(this._nsIPermissionManager);

      if (pm.testPermission(currentURI, "popup") == this._nsIPermissionManager.ALLOW_ACTION) {
        var blockString = this._multizillaBundle.formatStringFromName("popupBlock", [host], 1);
        blockedPopupAllowSite.setAttribute("label", blockString);
        blockedPopupAllowSite.setAttribute("block", "true");
      }
      else {
        var allowString = this._multizillaBundle.formatStringFromName("popupAllow", [host], 1);
        blockedPopupAllowSite.setAttribute("label", allowString);
        blockedPopupAllowSite.removeAttribute("block");
      }
    }
    catch (ex) {
      blockedPopupAllowSite.setAttribute("hidden", "true");
    }
    var item = aEvent.target.lastChild;

    while (item && item.getAttribute("observes") != "blockedPopupsSeparator") {
      var next = item.previousSibling;
      item.parentNode.removeChild(item);
      item = next;
    }
    var pageReport = gBrowser.mCurrentBrowser.mBlockedWindows;
    var blockedPopupsSeparator;

    if (pageReport && pageReport.length > 0) {
      blockedPopupsSeparator = document.getElementById("blockedPopupsSeparator");
      blockedPopupsSeparator.removeAttribute("hidden");

      for (var i = 0; i < pageReport.length; ++i) {
        var menuitem = document.createElement("menuitem");
        var label = this._multizillaBundle.formatStringFromName("popupShowPopupPrefix", [pageReport[i].popupWindowURI.spec], 1);
        menuitem.setAttribute("label", label);
        menuitem.setAttribute("requestingWindowURI", pageReport[i].requestingWindowURI.spec);
        menuitem.setAttribute("popupWindowURI", pageReport[i].popupWindowURI.spec);
        menuitem.setAttribute("popupWindowFeatures", pageReport[i].popupWindowFeatures);
        menuitem.setAttribute("oncommand", "gPopupBlockerObserver.openBlockedPopup(event);");
        aEvent.target.appendChild(menuitem);
      }
    }
    else {
      blockedPopupsSeparator = document.getElementById("blockedPopupsSeparator");
      blockedPopupsSeparator.setAttribute("hidden", "true");
    }
    var blockedPopupDontShowMessage = document.getElementById("blockedPopupDontShowMessage");
    var showMessage = mzPreferences.readMyPref("privacy.popups.showBrowserMessage", "bool", true);
    blockedPopupDontShowMessage.setAttribute("checked", !showMessage);

    if (aEvent.target.localName == "popup")
      blockedPopupDontShowMessage.setAttribute("label", this._multizillaBundle.GetStringFromName("popupWarningDontShowFromMessage"));
    else
      blockedPopupDontShowMessage.setAttribute("label", this._multizillaBundle.GetStringFromName("popupWarningDontShowFromStatusbar"));
  },
  
  openBlockedPopup: function(aEvent)
  {
    var requestingWindowURI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    requestingWindowURI.spec = aEvent.originalTarget.getAttribute("requestingWindowURI");
    // dump("\nrequestingWindowURI.spec: " + requestingWindowURI.spec);
    var popupWindowURI = aEvent.originalTarget.getAttribute("popupWindowURI");
    // dump("\npopupWindowURI: " + popupWindowURI);
    var features = aEvent.originalTarget.getAttribute("popupWindowFeatures");
    var shell = this.findChildShell(gBrowser.selectedBrowser.docShell, requestingWindowURI);
    // dump("\nfeatures: " + features);
    var regexp = new RegExp();
    var newWinFeatures = features || "";
    var windowFeatures = [ "minimizable", "resizable", "close", "scrollbars" ];

    for (var i in windowFeatures) {
      newWinFeatures = newWinFeatures.replace(regexp.compile(windowFeatures[i]+'=(0|no|false)', 'ig'), windowFeatures[i]);
      if (newWinFeatures.indexOf(windowFeatures[i]) < 0)
        newWinFeatures = newWinFeatures ? newWinFeatures + ',' + windowFeatures[i] : windowFeatures[i];
    }
    // dump("\nnewWinFeatures: " + newWinFeatures);
    if (shell) {
      // dump("\nshell found!");
      var ifr = shell.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
      var dwi = ifr.getInterface(Components.interfaces.nsIDOMWindowInternal);
      var infoMessage = gBrowser.getMessageForBrowser(gBrowser.selectedBrowser, gBrowser.mTopTabs ? "top" : "bottom");
      gBrowser.selectedBrowser.contentDocument.defaultView.mouseClick = infoMessage;
      /* var regexp = new RegExp();
      var newWinFeatures = features || "";
      var windowFeatures = [ "minimizable", "resizable", "close", "scrollbars" ];

      for (var i in windowFeatures) {
        newWinFeatures = newWinFeatures.replace(regexp.compile(windowFeatures[i]+'=(0|no|false)', 'ig'), windowFeatures[i]);
        if (newWinFeatures.indexOf(windowFeatures[i]) < 0)
          newWinFeatures = newWinFeatures ? newWinFeatures + ',' + windowFeatures[i] : windowFeatures[i];
      } */
      dwi.open(popupWindowURI, "", newWinFeatures);
    }
    else {
      // shell not found, but we should still be able to open this window!
      window.open(popupWindowURI, "", newWinFeatures);
    }
  },
  
  editPopupSettings: function()
  {
    var host = "";

    try {
      var uri = gBrowser.selectedBrowser.webNavigation.currentURI;
      host = (uri.scheme == "file") ? "file:" : uri.host;
    }
    catch (ex) {
    }
    mzManagers.openPermissionManager("popupManager-Preferences", host);
  },
  
  toggleShowMessagePref: function()
  {
    var prefValue = mzPreferences.readMyPref(this._popupInfoMessagePrefString, "bool", true);

    mzPreferences.writePref("bool", this._popupInfoMessagePrefString, !prefValue);
    gBrowser.hideInfoMessage(gBrowser.selectedBrowser);
  }
};
//////////////////////////////////////////////////////////////////////////
// function makeURL(aURL) was changed to makeURI(aURL, aOriginCharset)
// see also: https://bugzilla.mozilla.org/show_bug.cgi?id=160454
//////////////////////////////////////////////////////////////////////////
function makeURI(aURL, aOriginCharset)
{
  var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  return ioService.newURI(aURL, aOriginCharset, null);
}
//////////////////////////////////////////////////////////////////////////
function checkForMiddleClick(node, event)
{
  if (event.button == 1) {
    eval(node.getAttribute("oncommand"));
    closeMenus(event.target);
  }
}
//////////////////////////////////////////////////////////////////////////
function closeMenus(node)
{
  if ("tagName" in node) {
   if (node.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" && (node.tagName == "menupopup" || node.tagName == "popup"))
     node.hidePopup();
   closeMenus(node.parentNode);
  }
}
